/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.sql.SQLException;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.dao.CmCityDao;
import jp.mosp.payroll.dto.CmCityDto;
import jp.mosp.payroll.payment.vo.CityCardVo;

public class CityCardAction extends PayrollAction {
	
	// コマンド
	private static final String	CMD_CITY_CARD_SHOW		= "U5270";	// 表示(追加)
	private static final String	CMD_CITY_CARD_SELECT	= "U5271";	// 表示(選択)
	private static final String	CMD_CITY_CARD_INSERT	= "U5272";	// 登録
	private static final String	CMD_CITY_CARD_UPDATE	= "U5273";	// 更新
	private static final String	CMD_CITY_CARD_DELETE	= "U5274";	// 削除
																	
	
	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public CityCardAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new CityCardVo();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmPayrollAuth();
		// VO取得及び設定
		prepareVo();
		CityCardVo vo = (CityCardVo)getVo();
		vo.setMode(CityCardVo.MODE_INSERT);
		// 会社銀行コード取得
		vo.aryPltCoBankCode = getCoBankArray();
		// コマンド毎の処理
		// DTOの取得
		CmCityDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof CmCityDto ? (CmCityDto)obj : null;
		vo.setParams(request);
		if (cmd.equals(CMD_CITY_CARD_SHOW)) {
			// 表示処理
			// 検索履歴を初期値にセット
			vo.setTxtCityCode("");
			vo.setTxtCityName("");
			vo.setTxtCityKana("");
			vo.setTxtDesignatedNumber("");
			vo.setPltCoBankCode("");
			vo.setMode(CityCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_CITY_CARD_SELECT)) {
			// セッションにDTOをセット
			dto = select(vo);
			vo.setMode(CityCardVo.MODE_UPDATE);
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CITY_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CITY_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CITY_CARD_DELETE)) {
			// 削除
			delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	private CmCityDto select(CityCardVo vo) throws MospException, SQLException, IllegalAccessException,
			NoSuchFieldException {
		CmCityDao cmCityDao = new CmCityDao();
		cmCityDao.initDao(cfg, cmd, aspUser, user, conn);
		// 表示(キーで情報を検索)
		// データの取得
		CmCityDto cmCityDto = cmCityDao.findForKey(key1);
		chkExist(cmCityDto);
		// VOに情報をセット
		vo.setFields(cmCityDto);
		return cmCityDto;
	}
	
	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmCityDto insert(CityCardVo vo) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		// パラメータの妥当性確認
		vo.validate();
		CmCityDao cmCityDao = new CmCityDao();
		cmCityDao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(cmCityDao.findForKey(vo.getTxtCityCode()), vo);
		// DTOの準備
		CmCityDto cmCityDto = new CmCityDto();
		vo.setDtoFields(cmCityDto);
		// データの挿入
		cmCityDao.insert(cmCityDto);
		// DTOの再取得
		cmCityDto = cmCityDao.findForKey(cmCityDto.getCityCode());
		
		// コミット
		commit();
		// モード設定
		vo.setMode(CityCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return cmCityDto;
	}
	
	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmCityDto update(CityCardVo vo, CmCityDto dto) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		
		vo.setMode(CityCardVo.MODE_UPDATE);
		// パラメータの妥当性確認
		vo.validate();
		CmCityDao cmCityDao = new CmCityDao();
		cmCityDao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, cmCityDao.findForUpdate(vo.getTxtCityCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		cmCityDao.update(dto);
		// DTOの再取得
		CmCityDto retDto = cmCityDao.findForKey(dto.getCityCode());
		chkUpdate(retDto);
		
		// コミット
		commit();
		// モード設定
		vo.setMode(CityCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}
	
	/**
	 * データ削除
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @throws Exception
	 */
	public void delete(CityCardVo vo, CmCityDto dto) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		CmCityDao cmCityDao = new CmCityDao();
		cmCityDao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setDtoFields(dto);
		// データの更新
		cmCityDao.delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
	}
	
}
